Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.event
Class ContentHandlerProxy

    java.lang.Object
      net.sf.saxon.event.ContentHandlerProxy

All Implemented Interfaces:
  Result, Receiver

Direct Known Subclasses:
  TypedContentHandler

    public class ContentHandlerProxy

extends Object
implements Receiver

A ContentHandlerProxy is a Receiver that converts events into the form expected by an underlying SAX2 ContentHandler. Relevant events (notably comments) can also be fed to a LexicalHandler.

Note that in general the output passed to a Receiver corresponds to an External General Parsed Entity. A SAX2 ContentHandler only expects to deal with well-formed XML documents, so we only pass it the contents of the first element encountered, unless the saxon:require-well-formed output property is set to "no".

This ContentHandlerProxy provides no access to type information. For a ContentHandler that makes type information available, see `TypedContentHandler`

The ContentHandlerProxy can also be nominated as a TraceListener, to receive notification of trace events. This will be done automatically if the option setTraceListener(

Nested Class Summary
`static class` | `ContentHandlerProxy.ContentHandlerProxyTraceListener` Create a TraceListener that will collect information about the current location in the source document.

Field Summary
`protected ContentHandler` | `handler`
`protected LexicalHandler` | `lexicalHandler`
`protected AttributeCollectionImpl` | `pendingAttributes`

Fields inherited from interface javax.xml.transform.Result
`PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

Constructor Summary
`ContentHandlerProxy()`

Method Summary
`void` | `attribute(NodeName nameCode, SimpleType typeCode, CharSequence value, int locationId, int properties)` Notify an attribute.
`void` | `characters(CharSequence chars, int locationId, int properties)` Character data
`void` | `close()` Notify the end of the event stream
`void` | `comment(CharSequence chars, int locationId, int properties)` Output a comment.
`void` | `endDocument()` Notify the end of the document
`void` | `endElement()` End of element
`Configuration` | `getConfiguration()` Get the Saxon configuration
`long` | `getCurrentLocationId()` Get the current location identifier
`LocationProvider` | `getLocationProvider()` Get the location provider
`PipelineConfiguration` | `getPipelineConfiguration()` Get the pipeline configuration
`String` | `getSystemId()` Get the System ID of the destination tree
`ContentHandlerProxy.ContentHandlerProxyTraceListener` | `getTraceListener()` Get the associated TraceListener that receives notification of trace events
`ContentHandler` | `getUnderlyingContentHandler()` Get the underlying content handler
`boolean` | `isRequireWellFormed()` Ask whether the content handler can handle a stream of events that is merely well-balanced, or whether it can only handle a well-formed sequence.
`boolean` | `isUndeclareNamespaces()` Ask whether namespace undeclaration events (for a non-null prefix) should be notified.
`void` | `namespace(NamespaceBinding namespaceBinding, int properties)` Notify a namespace.
`protected void` | `notifyNotWellFormed()` The following function is called when it is found that the output is not a well-formed document.
`void` | `open()` Notify the start of the event stream
`void` | `processingInstruction(String target, CharSequence data, int locationId, int properties)` Processing Instruction
`void` | `setLexicalHandler(LexicalHandler handler)` Set the Lexical Handler to be used.
`void` | `setOutputProperties(Properties details)` Set the output details.
`void` | `setPipelineConfiguration(PipelineConfiguration pipe)` Set the pipeline configuration
`void` | `setRequireWellFormed(boolean wellFormed)` Set whether the content handler can handle a stream of events that is merely well-balanced, or whether it can only handle a well-formed sequence.
`void` | `setSystemId(String systemId)` Set the System ID of the destination tree
`void` | `setUndeclareNamespaces(boolean undeclareNamespaces)` Set whether namespace undeclaration events (for a non-null prefix) should be notified.
`void` | `setUnderlyingContentHandler(ContentHandler handler)` Set the underlying content handler.
`void` | `setUnparsedEntity(String name, String systemID, String publicID)` Notify an unparsed entity URI.
`void` | `startContent()` Notify the start of the content, that is, the completion of all attributes and namespaces.
`void` | `startDocument(int properties)` Notify the start of the document.
`void` | `startElement(NodeName nameCode, SchemaType typeCode, int locationId, int properties)` Notify the start of an element
`boolean` | `usesTypeAnnotations()` Ask whether this Receiver (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### handler

    protected ContentHandler handler

### lexicalHandler

    protected LexicalHandler lexicalHandler

### pendingAttributes

    protected AttributeCollectionImpl pendingAttributes

Constructor Detail

### ContentHandlerProxy

    public ContentHandlerProxy()

Method Detail

### setUnderlyingContentHandler

    public void setUnderlyingContentHandler(ContentHandler handler)

  Set the underlying content handler. This call is mandatory before using this Receiver. If the content handler is an instance of `LexicalHandler`, then it will also receive notification of lexical events such as comments.

  Parameters:
    `handler` - the SAX content handler to which all events will be directed

### getUnderlyingContentHandler

    public ContentHandler getUnderlyingContentHandler()

  Get the underlying content handler

  Returns:
    the SAX content handler to which all events are being directed

### setLexicalHandler

    public void setLexicalHandler(LexicalHandler handler)

  Set the Lexical Handler to be used. If called, this must be called AFTER setUnderlyingContentHandler()

  Parameters:
    `handler` - the SAX lexical handler to which lexical events (such as comments) will be notified.

### setPipelineConfiguration

    public void setPipelineConfiguration(PipelineConfiguration pipe)

  Set the pipeline configuration

  Specified by:
    `setPipelineConfiguration` in interface `Receiver`
  Parameters:
    `pipe` - the pipeline configuration

### getPipelineConfiguration

    public PipelineConfiguration getPipelineConfiguration()

  Get the pipeline configuration

  Specified by:
    `getPipelineConfiguration` in interface `Receiver`
  Returns:
    the pipeline configuration

### getConfiguration

    public Configuration getConfiguration()

  Get the Saxon configuration

  Returns:
    the Saxon configuration

### setSystemId

    public void setSystemId(String systemId)

  Set the System ID of the destination tree

  Specified by:
    `setSystemId` in interface `Result`
  Specified by:
    `setSystemId` in interface `Receiver`
  Parameters:
    `systemId` - the system ID (effectively the base URI)

### getSystemId

    public String getSystemId()

  Get the System ID of the destination tree

  Specified by:
    `getSystemId` in interface `Result`
  Returns:
    the system ID (effectively the base URI)

### getTraceListener

    public ContentHandlerProxy.ContentHandlerProxyTraceListener getTraceListener()

  Get the associated TraceListener that receives notification of trace events

  Returns:
    the trace listener. If there is no existing trace listener, then a new one will be created.

### getLocationProvider

    public LocationProvider getLocationProvider()

  Get the location provider

  Returns:
    the location provider, used to map location ids to actual URIs and line numbers

### getCurrentLocationId

    public long getCurrentLocationId()

  Get the current location identifier

  Returns:
    the location identifier of the most recent event. This can be translated to real location information by passing it to the location provider.

### setUnparsedEntity

    public void setUnparsedEntity(String name,
                                  String systemID,
                                  String publicID)
                           throws XPathException

  Notify an unparsed entity URI. This implementation does nothing: the event is ignored.

  Specified by:
    `setUnparsedEntity` in interface `Receiver`
  Parameters:
    `name` - The name of the unparsed entity
    `systemID` - The system identifier of the unparsed entity
    `publicID` - The public identifier of the unparsed entity
  Throws:
    `XPathException` - if an error occurs

### setOutputProperties

    public void setOutputProperties(Properties details)
                             throws XPathException

  Set the output details.

  Parameters:
    `details` - the serialization properties. The only values used by this implementation are `SaxonOutputKeys.REQUIRE_WELL_FORMED` and `SaxonOutputKeys.UNDECLARE_PREFIXES`.
  Throws:
    `XPathException`

### isRequireWellFormed

    public boolean isRequireWellFormed()

  Ask whether the content handler can handle a stream of events that is merely well-balanced, or whether it can only handle a well-formed sequence.

  Returns:
    true if the content handler requires the event stream to represent a well-formed XML document (containing exactly one top-level element node and no top-level text nodes)

### setRequireWellFormed

    public void setRequireWellFormed(boolean wellFormed)

  Set whether the content handler can handle a stream of events that is merely well-balanced, or whether it can only handle a well-formed sequence. The default is false.

  Parameters:
    `wellFormed` - set to true if the content handler requires the event stream to represent a well-formed XML document (containing exactly one top-level element node and no top-level text nodes). Otherwise, multiple top-level elements and text nodes are allowed, as in the XDM model.

### isUndeclareNamespaces

    public boolean isUndeclareNamespaces()

  Ask whether namespace undeclaration events (for a non-null prefix) should be notified. The default is no, because some ContentHandlers (e.g. JDOM) can't cope with them.

  Returns:
    true if namespace undeclarations (xmlns:p="") are to be output

### setUndeclareNamespaces

    public void setUndeclareNamespaces(boolean undeclareNamespaces)

  Set whether namespace undeclaration events (for a non-null prefix) should be notified. The default is no, because some ContentHandlers (e.g. JDOM) can't cope with them.

  Parameters:
    `undeclareNamespaces` - true if namespace undeclarations (xmlns:p="") are to be output

### open

    public void open()
              throws XPathException

  Notify the start of the event stream

  Specified by:
    `open` in interface `Receiver`
  Throws:
    `XPathException` - if an error occurs

### close

    public void close()
               throws XPathException

  Notify the end of the event stream

  Specified by:
    `close` in interface `Receiver`
  Throws:
    `XPathException` - if an error occurs

### startDocument

    public void startDocument(int properties)
                       throws XPathException

  Notify the start of the document.

  Specified by:
    `startDocument` in interface `Receiver`
  Parameters:
    `properties` - bit-significant integer indicating properties of the document node. The definitions of the bits are in class `ReceiverOptions`
  Throws:
    `XPathException` - if an error occurs

### endDocument

    public void endDocument()
                     throws XPathException

  Notify the end of the document

  Specified by:
    `endDocument` in interface `Receiver`
  Throws:
    `XPathException` - if an error occurs

### startElement

    public void startElement(NodeName nameCode,
                             SchemaType typeCode,
                             int locationId,
                             int properties)
                      throws XPathException

  Notify the start of an element

  Specified by:
    `startElement` in interface `Receiver`
  Parameters:
    `nameCode` - the name of the element.
    `typeCode` - the type annotation of the element.
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - bit-significant properties of the element node. If there are no revelant properties, zero is supplied. The definitions of the bits are in class `ReceiverOptions`
  Throws:
    `XPathException` - if an error occurs

### namespace

    public void namespace(NamespaceBinding namespaceBinding,
                          int properties)
                   throws XPathException

  Notify a namespace. Namespaces are notified after the startElement event, and before any children for the element.

  Specified by:
    `namespace` in interface `Receiver`
  Parameters:
    `namespaceBinding` - contains the namespace prefix and namespace URI
    `properties` - The most important property is REJECT_DUPLICATES. If this property is set, the namespace declaration will be rejected if it conflicts with a previous declaration of the same prefix. If the property is not set, the namespace declaration will be ignored if it conflicts with a previous declaration. This reflects the fact that when copying a tree, namespaces for child elements are emitted before the namespaces of their parent element. Unfortunately this conflicts with the XSLT rule for complex content construction, where the recovery action in the event of conflicts is to take the namespace that comes last. XSLT therefore doesn't recover from this error:
  Throws:
    `XPathException` - if an error occurs

### attribute

    public void attribute(NodeName nameCode,
                          SimpleType typeCode,
                          CharSequence value,
                          int locationId,
                          int properties)
                   throws XPathException

  Notify an attribute. Attributes are notified after the startElement event, and before any children.

  Specified by:
    `attribute` in interface `Receiver`
  Parameters:
    `nameCode` - The name of the attribute
    `typeCode` - The type of the attribute, as held in the name pool. The additional bit NodeInfo.IS_DTD_TYPE may be set to indicate a DTD-derived type.
    `value` - the string value of the attribute
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this attribute
  NO_SPECIAL_CHARACTERS
    Attribute value contains no special characters
  Throws:
    `XPathException` - if an error occurs

### startContent

    public void startContent()
                      throws XPathException

  Notify the start of the content, that is, the completion of all attributes and namespaces. Note that the initial receiver of output from XSLT instructions will not receive this event, it has to detect it itself. Note that this event is reported for every element even if it has no attributes, no namespaces, and no content.

  Specified by:
    `startContent` in interface `Receiver`
  Throws:
    `XPathException` - if an error occurs

### endElement

    public void endElement()
                    throws XPathException

  End of element

  Specified by:
    `endElement` in interface `Receiver`
  Throws:
    `XPathException` - if an error occurs

### characters

    public void characters(CharSequence chars,
                           int locationId,
                           int properties)
                    throws XPathException

  Character data

  Specified by:
    `characters` in interface `Receiver`
  Parameters:
    `chars` - The characters
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this text node
  USE_CDATA
    Output as a CDATA section
  Throws:
    `XPathException` - if an error occurs

### notifyNotWellFormed

    protected void notifyNotWellFormed()
                                throws XPathException

  The following function is called when it is found that the output is not a well-formed document. Unless the ContentHandler accepts "balanced content", this is a fatal error.

  Throws:
    `XPathException`

### processingInstruction

    public void processingInstruction(String target,
                                      CharSequence data,
                                      int locationId,
                                      int properties)
                               throws XPathException

  Processing Instruction

  Specified by:
    `processingInstruction` in interface `Receiver`
  Parameters:
    `target` - The PI name. This must be a legal name (it will not be checked).
    `data` - The data portion of the processing instruction
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the PI.
  Throws:
    `XPathException` - if an error occurs

### comment

    public void comment(CharSequence chars,
                        int locationId,
                        int properties)
                 throws XPathException

  Output a comment. Passes it on to the ContentHandler provided that the ContentHandler is also a SAX2 LexicalHandler.

  Specified by:
    `comment` in interface `Receiver`
  Parameters:
    `chars` - The content of the comment
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the comment.
  Throws:
    `XPathException` - if an error occurs

### usesTypeAnnotations

    public boolean usesTypeAnnotations()

  Ask whether this Receiver (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events

  Specified by:
    `usesTypeAnnotations` in interface `Receiver`
  Returns:
    true if the Receiver makes any use of this information. If false, the caller may supply untyped nodes instead of supplying the type annotation

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.